﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WSUniversalLib;

namespace WSUniversalLib
{
    public class Calculation
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="productType">Коэффициенты типа продукции</param>
        /// <param name="materialType">процент брака материала</param>
        /// <param name="count">количество продукции</param>
        /// <param name="width">ширина</param>
        /// <param name="length">длина</param>
        /// <returns>целое количество сырья</returns>
        public static int GetQuantityForProduct(int productType,int materialType,int count,float width,float length)
        {
            double area = width * length;//размер
            double coefficient = 1.0;

            // Определение коэффициента типа продукции
            switch (productType)
            {
                case 1:
                    coefficient = 1.1;
                    break;
                case 2:
                    coefficient = 2.5;
                    break;
                case 3:
                    coefficient = 8.43;
                    break;
                default:
                    return -1; // Несуществующий тип продукции
            }

            // Определение процента брака материала
            double defectRate = 0.0;
            switch (materialType)
            {
                case 1:
                    defectRate = 0.003; // 0.3%
                    break;
                case 2:
                    defectRate = 0.0012; // 0.12%
                    break;
                default:
                    return -1; // Несуществующий тип материала
            }

            double rawMaterialPerUnit = area * coefficient * (1 + defectRate);
            int result = Convert.ToInt32( rawMaterialPerUnit * count);
            return result;
       
        }
    }
}
